diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/DefaultFeatureTreePreferenecs.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/DefaultFeatureTreePreferenecs.java
index 862fb7ab2..6b9175e65 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/DefaultFeatureTreePreferenecs.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/DefaultFeatureTreePreferenecs.java
@@ -24,7 +24,8 @@ import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Control;
 
 import eu.etaxonomy.cdm.api.service.IFeatureTreeService;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.featuretree.FeatureTreeContentProvider;
 import eu.etaxonomy.taxeditor.featuretree.FeatureTreeLabelProvider;
 import eu.etaxonomy.taxeditor.l10n.Messages;
@@ -37,12 +38,11 @@ import eu.etaxonomy.taxeditor.store.CdmStore;
  *
  * @author n.hoffmann
  * @created Sep 16, 2010
- * @version 1.0
  */
 public class DefaultFeatureTreePreferenecs extends CdmPreferencePage {
 
-	private FeatureTree defaultFeatureTreeForTextualDescription;
-	private FeatureTree defaultFeatureTreeForStructuredDescription;
+	private TermTree<Feature> defaultFeatureTreeForTextualDescription;
+	private TermTree<Feature> defaultFeatureTreeForStructuredDescription;
 
 	/** {@inheritDoc} */
 	@Override
@@ -79,11 +79,11 @@ public class DefaultFeatureTreePreferenecs extends CdmPreferencePage {
 			    setApply(true);
 				IStructuredSelection selection = (IStructuredSelection) viewer.getSelection();
 
-				defaultFeatureTreeForTextualDescription = (FeatureTree) selection.getFirstElement();
+				defaultFeatureTreeForTextualDescription = (TermTree<Feature>)selection.getFirstElement();
 			}
 		});
 
-		List<FeatureTree> input = CdmStore.getService(IFeatureTreeService.class).list(FeatureTree.class, null, null, null, null);
+		List<TermTree<Feature>> input = (List)CdmStore.getService(IFeatureTreeService.class).list(TermTree.class, null, null, null, null);
 
 		viewer.setInput(input);
 
@@ -110,11 +110,11 @@ public class DefaultFeatureTreePreferenecs extends CdmPreferencePage {
 			    setApply(true);
 				IStructuredSelection selection = (IStructuredSelection) viewer.getSelection();
 
-				defaultFeatureTreeForStructuredDescription = (FeatureTree) selection.getFirstElement();
+				defaultFeatureTreeForStructuredDescription = (TermTree<Feature>) selection.getFirstElement();
 			}
 		});
 
-		List<FeatureTree> input = CdmStore.getService(IFeatureTreeService.class).list(FeatureTree.class, null, null, null, null);
+		List<TermTree<Feature>> input = (List)CdmStore.getService(IFeatureTreeService.class).list(TermTree.class, null, null, null, null);
 
 		viewer.setInput(input);
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/PreferencesUtil.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/PreferencesUtil.java
index 2e98c3ba4..fc6b8236a 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/PreferencesUtil.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/PreferencesUtil.java
@@ -51,6 +51,7 @@ import eu.etaxonomy.cdm.io.specimen.abcd206.in.Abcd206ImportConfigurator;
 import eu.etaxonomy.cdm.model.common.ICdmBase;
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.common.MarkerType;
+import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.metadata.CdmPreference;
 import eu.etaxonomy.cdm.model.metadata.CdmPreference.PrefKey;
 import eu.etaxonomy.cdm.model.metadata.IPreferencePredicate;
@@ -58,10 +59,10 @@ import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
 import eu.etaxonomy.cdm.model.metadata.PreferenceSubject;
 import eu.etaxonomy.cdm.model.metadata.TermDisplayEnum;
 import eu.etaxonomy.cdm.model.name.NomenclaturalCode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
 import eu.etaxonomy.cdm.model.term.IDefinedTerm;
 import eu.etaxonomy.cdm.model.term.ISimpleTerm;
 import eu.etaxonomy.cdm.model.term.TermBase;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.strategy.match.DefaultMatchStrategy;
 import eu.etaxonomy.cdm.strategy.match.FieldMatcher;
 import eu.etaxonomy.cdm.strategy.match.IMatchStrategy;
@@ -961,13 +962,13 @@ public class PreferencesUtil implements IPreferenceKeys {
         return false;
     }
 
-    public static FeatureTree getDefaultFeatureTreeForTextualDescription() {
+    public static TermTree<Feature> getDefaultFeatureTreeForTextualDescription() {
         String uuidString = getStringValue(
                 FEATURE_TREE_DEFAULT_TEXT);
         if (StringUtils.isBlank(uuidString)) {
             return null;
         }
-        FeatureTree tree = CdmStore.getService(
+        TermTree<Feature> tree = CdmStore.getService(
                     IFeatureTreeService.class).load(UUID.fromString(uuidString));
         if (tree.getId() == 0) {
             return null;
@@ -975,10 +976,10 @@ public class PreferencesUtil implements IPreferenceKeys {
         return tree;
     }
 
-    public static FeatureTree getDefaultFeatureTreeForStructuredDescription() {
+    public static TermTree<Feature> getDefaultFeatureTreeForStructuredDescription() {
         String uuidString = getStringValue(
                 FEATURE_TREE_DEFAULT_STRUCTURE);
-        return CdmUtils.isEmpty(uuidString) ? null : CdmStore.getService(
+        return StringUtils.isBlank(uuidString) ? null : CdmStore.getService(
                 IFeatureTreeService.class).load(UUID.fromString(uuidString));
     }
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/menu/NameFeatureMenuPreference.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/menu/NameFeatureMenuPreference.java
index c5be640f2..bb76a052b 100755
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/menu/NameFeatureMenuPreference.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/preference/menu/NameFeatureMenuPreference.java
@@ -35,9 +35,6 @@ public class NameFeatureMenuPreference extends AbstractMenuPreferences<Feature>
                 false);
     }
 
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.taxeditor.preference.menu.AbstractMenuPreferences#getTermClass()
-     */
     /** {@inheritDoc} */
     @Override
     protected TermType getTermType() {
@@ -46,9 +43,9 @@ public class NameFeatureMenuPreference extends AbstractMenuPreferences<Feature>
     @Override
     protected List<Feature> getTerms(){
         if(CdmStore.isActive() ){
-            List<Feature> termList = new ArrayList(TermEditorInput.getDefaultNameFeatureTree().getDistinctFeatures());
+            List<Feature> termList = new ArrayList(TermEditorInput.getDefaultNameFeatureTree().getDistinctTerms());
             return termList;
         }
-        return new ArrayList<Feature>();
+        return new ArrayList<>();
     }
 }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/store/CdmStore.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/store/CdmStore.java
index f69e23e89..398ea677c 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/store/CdmStore.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/store/CdmStore.java
@@ -70,8 +70,8 @@ import eu.etaxonomy.cdm.model.common.Group;
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.term.TermVocabulary;
 import eu.etaxonomy.cdm.model.description.DescriptionBase;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.term.TermNode;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.model.description.PolytomousKey;
 import eu.etaxonomy.cdm.model.description.PolytomousKeyNode;
 import eu.etaxonomy.cdm.model.description.DescriptiveDataSet;
@@ -728,10 +728,10 @@ public class CdmStore {
             else if (cdmBase instanceof EntityValidation) {
                 service = (IService<T>) getService(IEntityValidationService.class);
             }
-            else if (cdmBase instanceof FeatureNode) {
+            else if (cdmBase instanceof TermNode) {
                 service = (IService<T>) getService(IFeatureNodeService.class);
             }
-            else if (cdmBase instanceof FeatureTree) {
+            else if (cdmBase instanceof TermTree) {
                 service = (IService<T>) getService(IFeatureTreeService.class);
             }
             else if (cdmBase instanceof GrantedAuthority) {
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/AbstractFilteredCdmResourceSelectionDialog.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/AbstractFilteredCdmResourceSelectionDialog.java
index dec0ff3ef..0373c0cc7 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/AbstractFilteredCdmResourceSelectionDialog.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/AbstractFilteredCdmResourceSelectionDialog.java
@@ -68,12 +68,10 @@ public abstract class AbstractFilteredCdmResourceSelectionDialog<T extends ICdmB
 //	private final ConversationHolder conversation = null;
 
 	protected List<UuidAndTitleCache<T>> model;
-	private final Set<T> transientCdmObjects = new HashSet<T>();
+	private final Set<T> transientCdmObjects = new HashSet<>();
 	private final String settings;
 	protected final Integer limitOfInitialElements = null;
 
-	private T selectedObject;
-
 	protected Set<UUID> cdmBaseToBeFiltered;
 
 	protected Job searchJob;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/FeatureTreeSelectionDialog.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/FeatureTreeSelectionDialog.java
index 6abad824e..82e7e606c 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/FeatureTreeSelectionDialog.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/FeatureTreeSelectionDialog.java
@@ -19,8 +19,9 @@ import org.eclipse.swt.events.SelectionListener;
 import org.eclipse.swt.widgets.Shell;
 
 import eu.etaxonomy.cdm.api.service.IFeatureTreeService;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.model.term.TermType;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
 import eu.etaxonomy.taxeditor.l10n.Messages;
 import eu.etaxonomy.taxeditor.newWizard.AbstractNewEntityWizard;
 import eu.etaxonomy.taxeditor.store.CdmStore;
@@ -30,17 +31,17 @@ import eu.etaxonomy.taxeditor.store.CdmStore;
  * @created Sep 17, 2010
  */
 public class FeatureTreeSelectionDialog extends
-		AbstractFilteredCdmResourceSelectionDialog<FeatureTree> {
+		AbstractFilteredCdmResourceSelectionDialog<TermTree<Feature>> {
 
     private final TermType termType;
 
-    public static FeatureTree select(Shell shell,
-            FeatureTree featureTree) {
+    public static TermTree<Feature> select(Shell shell,
+    		TermTree<Feature> featureTree) {
         return select(shell, featureTree, null);
 
     }
-	public static FeatureTree select(Shell shell,
-	        FeatureTree featureTree, TermType termType) {
+	public static TermTree<Feature> select(Shell shell,
+	        TermTree<Feature> featureTree, TermType termType) {
 		FeatureTreeSelectionDialog dialog = new FeatureTreeSelectionDialog(shell,
 				Messages.FeatureTreeSelectionDialog_CHOOSE_TREE, false, featureTree, termType);
 		return getSelectionFromDialog(dialog);
@@ -48,19 +49,19 @@ public class FeatureTreeSelectionDialog extends
 
 	protected FeatureTreeSelectionDialog(Shell shell,
 			 String title, boolean multi,
-			FeatureTree cdmObject, TermType termType) {
+			 TermTree<Feature> cdmObject, TermType termType) {
 		super(shell, title, multi, FeatureTreeSelectionDialog.class.getCanonicalName(), cdmObject);
 		this.termType = termType;
 	}
 
 	@Override
-	protected FeatureTree getPersistentObject(UUID uuid) {
+	protected TermTree<Feature> getPersistentObject(UUID uuid) {
 		return CdmStore.getService(IFeatureTreeService.class).load(uuid);
 	}
 
 	@Override
 	protected void callService(String pattern) {
-        model = CdmStore.getService(IFeatureTreeService.class).getUuidAndTitleCacheByTermType(FeatureTree.class, termType, limitOfInitialElements, pattern);
+        model = CdmStore.getService(IFeatureTreeService.class).getUuidAndTitleCacheByTermType(TermTree.class, termType, limitOfInitialElements, pattern);
 	}
 
 	@Override
@@ -72,12 +73,12 @@ public class FeatureTreeSelectionDialog extends
                 InputDialog dialog = new InputDialog(getShell(), Messages.FeatureTreeSelectionDialog_TREE_LABEL, Messages.FeatureTreeSelectionDialog_ENTER_LABEL, null, null);
                 if (dialog.open() == Window.OK) {
                     // User clicked OK; update the label with the input
-                    FeatureTree tree = null;
+                	TermTree<Feature> tree = null;
                     if(termType!=null){
-                        tree = FeatureTree.NewInstance(termType);
+                        tree = TermTree.NewInstance(termType);
                     }
                     else{
-                        tree = FeatureTree.NewInstance();
+                        tree = TermTree.NewInstance();
                     }
                     tree.setTitleCache(dialog.getValue(), true);
                     CdmStore.getService(IFeatureTreeService.class).merge(tree,true);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/SelectionDialogFactory.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/SelectionDialogFactory.java
index 111cfab25..31fe8187e 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/SelectionDialogFactory.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/dialog/selection/SelectionDialogFactory.java
@@ -44,7 +44,7 @@ import eu.etaxonomy.cdm.model.taxon.Synonym;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonBase;
 import eu.etaxonomy.cdm.model.taxon.TaxonNode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.model.MessagingUtils;
 import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
@@ -139,9 +139,9 @@ public class SelectionDialogFactory {
 			return (T) FeatureSelectionDialog.select(shell, //conversation,
 			        (Feature) currentSelection);
 		}
-		if(clazz.equals(FeatureTree.class)){
+		if(clazz.equals(TermTree.class)){
 			return (T) FeatureTreeSelectionDialog.select(shell, //conversation,
-			        (FeatureTree) currentSelection);
+			        (TermTree) currentSelection);
 		}
 		if(clazz.equals(PolytomousKey.class)){
 			return (T) PolytomousKeySelectionDialog.select(shell, //conversation,
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/NaturalLanguageDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/NaturalLanguageDetailElement.java
index fa090b3ab..077b4e9f5 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/NaturalLanguageDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/NaturalLanguageDetailElement.java
@@ -20,9 +20,10 @@ import org.eclipse.e4.ui.workbench.modeling.EPartService;
 import org.eclipse.swt.widgets.Display;
 
 import eu.etaxonomy.cdm.api.service.NaturalLanguageGenerator;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.description.TextData;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.model.AbstractUtility;
 import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
 import eu.etaxonomy.taxeditor.store.CdmStore;
@@ -83,7 +84,7 @@ public class NaturalLanguageDetailElement extends AbstractCdmDetailElement<Taxon
 
 		private TaxonDescription entity;
 		private NaturalLanguageGenerator generator = new NaturalLanguageGenerator();
-		private FeatureTree featureTree = PreferencesUtil.getDefaultFeatureTreeForStructuredDescription();
+		private TermTree<Feature> featureTree = PreferencesUtil.getDefaultFeatureTreeForStructuredDescription();
 		private Display display = Display.getCurrent();
 
 		public FetchNaturalLanguageDescriptionJob(String jobName, TaxonDescription entity){
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/CharacterDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/CharacterDetailElement.java
index 87e0af057..8664e19d1 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/CharacterDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/CharacterDetailElement.java
@@ -12,9 +12,10 @@ import org.eclipse.swt.widgets.Label;
 
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.description.Character;
+import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.term.DefinedTerm;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
 import eu.etaxonomy.cdm.model.term.Representation;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.cdm.model.term.TermType;
 import eu.etaxonomy.taxeditor.editor.definedterm.TermBasePropertyTester;
 import eu.etaxonomy.taxeditor.model.ColorResources;
@@ -109,9 +110,9 @@ public class CharacterDetailElement extends AbstractCdmDetailElement<Character>
         }
     }
 
-	private String getPath(FeatureNode node){
+	private String getPath(TermNode<Feature> node){
 	    String path = node.getTerm().getLabel();
-	    FeatureNode parent = node.getParent();
+	    TermNode<Feature> parent = node.getParent();
 	    while(parent != null && parent.getTerm()!=null){
 	        path = parent.getTerm().getLabel() + "/" + path;
 	        parent = parent.getParent();
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureNodeDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureNodeDetailElement.java
index aea88de0c..28017a7a1 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureNodeDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureNodeDetailElement.java
@@ -8,7 +8,8 @@
 */
 package eu.etaxonomy.taxeditor.ui.section.feature;
 
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.store.StoreUtil;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
@@ -21,7 +22,7 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
  * @since Dec 21, 2017
  *
  */
-public class FeatureNodeDetailElement extends AbstractCdmDetailElement<FeatureNode> {
+public class FeatureNodeDetailElement extends AbstractCdmDetailElement<TermNode<Feature>> {
 
     private InapplicableIfEntityCollectionSection sectionInapplicableIf;
     private OnlyApplicableIfEntityCollectionSection sectionOnlyApplicableIf;
@@ -32,7 +33,7 @@ public class FeatureNodeDetailElement extends AbstractCdmDetailElement<FeatureNo
 	}
 
 	@Override
-	protected void createControls(ICdmFormElement formElement, FeatureNode entity, int style) {
+	protected void createControls(ICdmFormElement formElement, TermNode<Feature> entity, int style) {
 	    sectionInapplicableIf = formFactory.createInapplicableIfEntityCollectionSection(getConversationHolder(),
                     formElement, StoreUtil.getSectionStyle(InapplicableIfEntityCollectionSection.class, getEntity().getClass().getCanonicalName()));
 	    sectionInapplicableIf.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureNodeDetailSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureNodeDetailSection.java
index 22c95b7f1..9395a92b9 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureNodeDetailSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureNodeDetailSection.java
@@ -11,7 +11,8 @@ package eu.etaxonomy.taxeditor.ui.section.feature;
 import org.eclipse.jface.viewers.ISelectionProvider;
 
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
@@ -23,7 +24,7 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
  * @since Dec 21, 2017
  *
  */
-public class FeatureNodeDetailSection extends AbstractCdmDetailSection<FeatureNode> {
+public class FeatureNodeDetailSection extends AbstractCdmDetailSection<TermNode<Feature>> {
 
 	public FeatureNodeDetailSection(CdmFormFactory formFactory,
 	        ConversationHolder conversation, ICdmFormElement parentElement,
@@ -33,14 +34,14 @@ public class FeatureNodeDetailSection extends AbstractCdmDetailSection<FeatureNo
 
 	@Override
 	public String getHeading() {
-		return FeatureNode.class.getSimpleName();
+		return TermNode.class.getSimpleName();
 	}
 
     /**
      * {@inheritDoc}
      */
     @Override
-    protected AbstractCdmDetailElement<FeatureNode> createCdmDetailElement(AbstractCdmDetailSection<FeatureNode> parentElement,
+    protected AbstractCdmDetailElement<TermNode<Feature>> createCdmDetailElement(AbstractCdmDetailSection<TermNode<Feature>> parentElement,
             int style) {
         return formFactory.createFeatureNodeDetailElement(parentElement, style);
     }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureTreeDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureTreeDetailElement.java
index 7bfa04b0e..559ce8a5d 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureTreeDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureTreeDetailElement.java
@@ -10,7 +10,8 @@ package eu.etaxonomy.taxeditor.ui.section.feature;
 
 import org.eclipse.swt.widgets.Label;
 
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.model.ColorResources;
 import eu.etaxonomy.taxeditor.preference.Resources;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
@@ -23,7 +24,7 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractIdentifiableEntityDetailElement
  * @since Dec 21, 2017
  *
  */
-public class FeatureTreeDetailElement extends AbstractIdentifiableEntityDetailElement<FeatureTree> {
+public class FeatureTreeDetailElement extends AbstractIdentifiableEntityDetailElement<TermTree<Feature>> {
 
 	public FeatureTreeDetailElement(CdmFormFactory formFactory,
 			ICdmFormElement formElement) {
@@ -32,7 +33,7 @@ public class FeatureTreeDetailElement extends AbstractIdentifiableEntityDetailEl
 
 
 	@Override
-	protected void createControls(ICdmFormElement formElement, FeatureTree entity, int style) {
+	protected void createControls(ICdmFormElement formElement, TermTree<Feature> entity, int style) {
 	    Label lblTermType = new Label(formElement.getLayoutComposite(), style);
 	    lblTermType.setText("Term Type");
 	    Label lblStructureText = new Label(formElement.getLayoutComposite(), style);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureTreeDetailSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureTreeDetailSection.java
index c1c735c4d..a86d6d762 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureTreeDetailSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/FeatureTreeDetailSection.java
@@ -11,7 +11,8 @@ package eu.etaxonomy.taxeditor.ui.section.feature;
 import org.eclipse.jface.viewers.ISelectionProvider;
 
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
@@ -23,7 +24,7 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
  * @since Dec 21, 2017
  *
  */
-public class FeatureTreeDetailSection extends AbstractCdmDetailSection<FeatureTree> {
+public class FeatureTreeDetailSection extends AbstractCdmDetailSection<TermTree<Feature>> {
 
 	public FeatureTreeDetailSection(CdmFormFactory formFactory,
 	        ConversationHolder conversation, ICdmFormElement parentElement,
@@ -33,14 +34,14 @@ public class FeatureTreeDetailSection extends AbstractCdmDetailSection<FeatureTr
 
 	@Override
 	public String getHeading() {
-		return FeatureTree.class.getSimpleName();
+		return TermTree.class.getSimpleName();
 	}
 
     /**
      * {@inheritDoc}
      */
     @Override
-    protected AbstractCdmDetailElement<FeatureTree> createCdmDetailElement(AbstractCdmDetailSection<FeatureTree> parentElement,
+    protected AbstractCdmDetailElement<TermTree<Feature>> createCdmDetailElement(AbstractCdmDetailSection<TermTree<Feature>> parentElement,
             int style) {
         return formFactory.createFeatureTreeDetailElement(parentElement, style);
     }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/InapplicableIfCollectionElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/InapplicableIfCollectionElement.java
index eba0c7d51..6c752c1ff 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/InapplicableIfCollectionElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/InapplicableIfCollectionElement.java
@@ -11,9 +11,10 @@ package eu.etaxonomy.taxeditor.ui.section.feature;
 import org.eclipse.swt.events.SelectionListener;
 import org.eclipse.swt.graphics.Color;
 
-import eu.etaxonomy.cdm.model.term.TermType;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.State;
+import eu.etaxonomy.cdm.model.term.TermNode;
+import eu.etaxonomy.cdm.model.term.TermType;
 import eu.etaxonomy.taxeditor.ui.combo.TermComboElement;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
@@ -54,7 +55,7 @@ public class InapplicableIfCollectionElement extends AbstractEntityCollectionEle
         if(eventSource==comboState && comboState.getSelection()!=null){
             if(getParentElement() instanceof InapplicableIfEntityCollectionSection){
                 InapplicableIfEntityCollectionSection parentElement = (InapplicableIfEntityCollectionSection) getParentElement();
-                FeatureNode node = parentElement.getEntity();
+                TermNode<Feature> node = parentElement.getEntity();
                 node.removeInapplicableState(entity);
                 State state = comboState.getSelection();
                 node.addInapplicableState(state);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/InapplicableIfEntityCollectionSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/InapplicableIfEntityCollectionSection.java
index bbc344cad..972daa687 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/InapplicableIfEntityCollectionSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/feature/InapplicableIfEntityCollectionSection.java
@@ -13,8 +13,9 @@ import java.util.Collection;
 import java.util.Comparator;
 
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.State;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.DefaultCdmBaseComparator;
@@ -25,7 +26,7 @@ import eu.etaxonomy.taxeditor.ui.section.occurrence.dna.AbstractUnboundEntityCol
  * @date 06.03.2018
  *
  */
-public class InapplicableIfEntityCollectionSection extends AbstractUnboundEntityCollectionSection<FeatureNode, State>{
+public class InapplicableIfEntityCollectionSection extends AbstractUnboundEntityCollectionSection<TermNode<Feature>, State>{
 
     public InapplicableIfEntityCollectionSection(CdmFormFactory formFactory, ConversationHolder conversation,
             ICdmFormElement parentElement, int style) {
@@ -36,7 +37,7 @@ public class InapplicableIfEntityCollectionSection extends AbstractUnboundEntity
      * {@inheritDoc}
      */
     @Override
-    protected Collection<State> getEntityCollection(FeatureNode entity) {
+    protected Collection<State> getEntityCollection(TermNode<Feature> entity) {
         return entity.getInapplicableIf();
     }
 
